%bcond_without docs

Name:       idp3
Version:    3.7.1
Release:    1%{?dist}
Summary:    Knowledge Base System for the FO-dot language


License:    LGPL-3.0-only AND GPL-2.0-or-later AND GPL-3.0-or-later AND BSD-2-Clause AND BSD-2-Clause-Views AND BSD-3-Clause AND MIT AND MS-PL AND FSFULLR AND Zlib
URL:        https://dtai.cs.kuleuven.be/pages/software/idp/try
Source0:    https://dtai.cs.kuleuven.be/static/krr/files/software/%{name}/%{name}-%{version}_sources.zip

Patch0:     idp3-fix-no-narrowing.patch
Patch1:     idp3-fix-comparison.patch
Patch2:     idp3-no-static-libstdc++.patch
Patch3:     idp3-fix-docs.patch
Patch4:     idp3-fix-xsb.patch
Patch5:     idp3-fix-minisatid.patch
Patch6:     idp3-fix-spass.patch

BuildRequires:  bison
BuildRequires:  cmake
BuildRequires:  desktop-file-utils
BuildRequires:  flex
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  texinfo

# docs
%if %{with docs}
BuildRequires:  ImageMagick
BuildRequires:  latex2html
BuildRequires:  poppler-utils
BuildRequires:  texlive-bibtex
BuildRequires:  texlive-dvips
BuildRequires:  texlive-ec
BuildRequires:  texlive-glossaries-english
BuildRequires:  texlive-latex
BuildRequires:  texlive-makeindex
BuildRequires:  texlive-metafont
BuildRequires:  tex(amsmath.sty)
BuildRequires:  tex(amssymb.sty)
BuildRequires:  tex(amsthm.sty)
BuildRequires:  tex(datatool.sty)
BuildRequires:  tex(english.ldf)
BuildRequires:  tex(fontenc.sty)
BuildRequires:  tex(glossaries.sty)
BuildRequires:  tex(ifthen.sty)
BuildRequires:  tex(import.sty)
BuildRequires:  tex(soul.sty)
BuildRequires:  tex(url.sty)
BuildRequires:  tex(xcolor.sty)
BuildRequires:  tex(xparse.sty)
BuildRequires:  tex(xspace.sty)
%endif


%description
IDP is a knowledge Base System (KB-system) for the FO(·) language. A Knowledge
Base system is a system that supports multiple forms of inferences for the 
same Knowledge Base. FO(·) (aka FO-dot) is an extension of 
first-order logic (FO) with types, aggregates, inductive definitions, 
bounded arithmetic, partial functions, etc.


%prep
%autosetup -n idp -p1
rm -rf .git

# fix minimum cmake version
find -type f -name CMakeLists.txt -exec sed -i 's/\(cmake_minimum_required\s*(VERSION\s2\(\.[[:digit:]]\+\)\{0,2\}\))\s*$/\1...3.26)/gi' {} \;

%build
%if %{with docs}
%cmake -DCMAKE_INSTALL_PREFIX:PATH=%{_libdir}/%{name} -DBUILDDOCUMENTATION=ON
%else
%cmake -DCMAKE_INSTALL_PREFIX:PATH=%{_libdir}/%{name} -DBUILDDOCUMENTATION=OFF
%endif

%cmake_build

%install
%cmake_install

# Run xsb to compile config file
%{buildroot}%{_libdir}/%{name}/bin/xsb-3.7.0/bin/xsb </dev/null

# Create executable symlink
mkdir -p %{buildroot}%{_bindir}
ln -s ../%{_lib}/idp3/bin/idp %{buildroot}%{_bindir}/idp


%files
%doc README.md
%license COPYRIGHT COPYING.LESSER
%{_bindir}/idp
%{_libdir}/idp3


%changelog
* Fri Apr 28 2023 Arthur Bols <arthur@bols.dev> - 3.7.1-1
- Initial package
